SystemOrganization addCategory: #'EjerciciosPoo-TusLibros'!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/13/2012 17:38'!
book1FromEditorial1 

	^'Book10'! !

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/13/2012 17:38'!
book2FromEditorial1 

	^'Book11'! !

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/13/2012 17:42'!
bookFromEditorial2 

	^'Book20'! !

!TusLibrosTest methodsFor: 'errors' stamp: 'IgalFrid 6/8/2012 17:45'!
canNotAddABookFromOtherEditorialToACart
	
	^CanNotAddABookFromOtherEditorialToACart! !

!TusLibrosTest methodsFor: 'errors' stamp: 'IgalFrid 6/13/2012 17:18'!
canNotAddABookWithAmountLessThanOne 
	
	^CanNotAddABookWithAmountLessThanOne! !

!TusLibrosTest methodsFor: 'carts' stamp: 'IgalFrid 6/13/2012 21:24'!
cartFromEditorial2 
	
	^Cart newWithCatalog: self listOfBooks2.! !

!TusLibrosTest methodsFor: 'carts' stamp: 'IgalFrid 6/13/2012 21:27'!
cartWithTwoBooksFromEditorial1 
	
	| cart |
	
	cart := Cart newWithCatalog: self catalog1.
	cart add: self book1FromEditorial1 amount: 4.
	cart add: self book2FromEditorial1 amount: 3.
	
	^cart! !

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/13/2012 21:28'!
catalog1
	| catalog |
	
	catalog:= Set new.
	catalog add: 'Book10'; add: 'Book11'.
	^catalog! !

!TusLibrosTest methodsFor: 'carts' stamp: 'IgalFrid 6/13/2012 21:27'!
emptyCart 
	
	^Cart newWithCatalog: self catalog1.! !

!TusLibrosTest methodsFor: 'books' stamp: 'IgalFrid 6/13/2012 17:47'!
listOfBooks2
	| books |
	
	books := Set new.
	books add: (Book newWithIsbn:'Book20' price: 5); add: (Book newWithIsbn:'Book21' price: 7).
	^books! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 21:24'!
test01NewCartShouldBeEmpty

	self assert: self emptyCart isEmpty! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 21:42'!
test02CanAddAnItemFromTheCatalog

	| cart |
	
	cart := self emptyCart.
	cart add: self book1FromEditorial1 amount:1.
	self deny: cart isEmpty! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 21:41'!
test03CannotAddAnItemNotInTheCatalog
	
	| cart |
	
	cart := self emptyCart.
	self should: [cart add: self bookFromEditorial2] 
		raise: Error
		withExceptionDo: [:anException | 
							self assert: anException messageText = 'No se puede agregar un libro de otra editorial'.
							self assert: cart isEmpty 
							]! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 21:43'!
test04CanAddMoreThanAnItemAtATime

	| cart |
	
	cart := self emptyCart.
	cart add: self book1FromEditorial1 amount: 2.
	self assert: cart size = 2 ! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 21:45'!
test05CannotAddAmountsLessThanOne
	
	| cart |
	
	cart := self emptyCart.
	self should: [ cart add: self book1FromEditorial1 amount: 0] 
		raise: Error
		withExceptionDo: [:anException | 
							self assert: anException messageText = 'No se pueden agregar cantidades menores a 1'.
							self assert: cart isEmpty 
						].
	self should: [ cart add: self book1FromEditorial1 amount: -2]
		raise: Error
		withExceptionDo: [:anException | 
							self assert: anException messageText = 'No se pueden agregar cantidades menores a 1'.
							self assert: cart isEmpty 
						].! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 21:45'!
test06AmountOfBooksOfANotExistsItem

	self assert: (self emptyCart amountOf: 'Book10') = 0 
! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 21:48'!
test07CartHasACorrectAmountOfItems

	| cart |
	
	cart := self emptyCart.
	cart add: self book1FromEditorial1 amount: 4.
	cart add: self book1FromEditorial1 amount: 3.
	
	self assert: (cart amountOf: self book1FromEditorial1) = 7 
 ! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 21:48'!
test09TwoNewCartsShouldNotBeEquals

	self deny: (self emptyCart = self emptyCart)! !

!TusLibrosTest methodsFor: '1 - Test cart' stamp: 'IgalFrid 6/13/2012 18:07'!
test10CartCorrectlyListItsRequestedBooks

	| books|
	
	books := Bag new.
	books add: self book1FromEditorial1 withOccurrences: 4.
	books add: self book2FromEditorial1 withOccurrences: 3.
	
	self assert: (self cartWithTwoBooksFromEditorial1 contents) = books 
 ! !

Object subclass: #Cart
	instanceVariableNames: 'cartId catalog items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-TusLibros'!

Cart class
	instanceVariableNames: 'lastCartId'!

Cart class
	instanceVariableNames: 'lastCartId'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 18:52'!
lastCartId
	
	^lastCartId! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 18:52'!
lastCartId: anInteger
	
	lastCartId := anInteger! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 21:25'!
newWithCatalog: aCatalog
	
	^self new initializeWithCatalog: aCatalog! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 18:55'!
= aCart
	
	^cartId = aCart cartId! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 21:31'!
add: anItem
	
	self verifyIfAnItem: anItem existsInCatalogAndDo: [items add: anItem]! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 21:38'!
add: anItem amount: anInteger
	
	(anInteger > 0)
	ifTrue: [self verifyIfAnItem: anItem existsInCatalogAndDo: [items add: anItem withOccurrences: anInteger]]
	ifFalse: [Error signal: 'No se pueden agregar cantidades menores a 1']! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 21:31'!
amountOf: aTitle
	
	^items occurrencesOf: aTitle! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 21:31'!
books
	
	| books |
	
	books := Set new.
	
	items do: [:book | books add: book isbn].
	
	^books! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 18:53'!
cartId
	
	^cartId! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 21:31'!
contents
	
	^items! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 21:31'!
initializeWithCatalog: aCatalog
	
	(Cart lastCartId isNil)
		ifTrue: [Cart lastCartId: 1]
		ifFalse: [Cart lastCartId: Cart lastCartId + 1].
		
	cartId := Cart lastCartId.
	catalog := aCatalog.
	items := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 21:31'!
isEmpty 
	
	^items isEmpty ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 21:43'!
size
	
	^items size! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 21:31'!
totalAmount
	
	| total |
	
	total := 0.
	
	items do: [:isbn | total := total + (catalog detect: [:book | book isbn = isbn]) price].
	
	^total! !

!Cart methodsFor: 'as yet unclassified' stamp: 'IgalFrid 6/13/2012 21:30'!
verifyIfAnItem: anItem existsInCatalogAndDo: aBlock
	
	(catalog includes: anItem) 
		ifTrue: aBlock
		ifFalse: [Error signal: 'No se puede agregar un libro de otra editorial']! !
